VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Subclass Textbox"
   ClientHeight    =   2745
   ClientLeft      =   5445
   ClientTop       =   1860
   ClientWidth     =   4350
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2745
   ScaleWidth      =   4350
   Begin VB.Frame Frame1 
      Caption         =   "Textbox lets you undo changes"
      Height          =   1335
      Left            =   120
      TabIndex        =   9
      Top             =   1320
      Width           =   4095
      Begin VB.CommandButton cmdUndo 
         Caption         =   "Undo"
         Height          =   375
         Left            =   3120
         TabIndex        =   3
         ToolTipText     =   "Undo changes"
         Top             =   360
         Width           =   855
      End
      Begin VB.CommandButton cmdClear 
         Caption         =   "Save"
         Height          =   375
         Left            =   120
         TabIndex        =   4
         ToolTipText     =   "Make the current text the 'undo' text."
         Top             =   840
         Width           =   855
      End
      Begin VB.CommandButton cmdChanged 
         Caption         =   "Change?"
         Height          =   375
         Left            =   2040
         TabIndex        =   6
         ToolTipText     =   "Click to see if the text changed."
         Top             =   840
         Width           =   855
      End
      Begin VB.CommandButton cmdMark 
         Caption         =   "Mark"
         Height          =   375
         Left            =   1080
         TabIndex        =   5
         ToolTipText     =   "Mark the text as being changed."
         Top             =   840
         Width           =   855
      End
      Begin VB.CommandButton cmdCanUndo 
         Caption         =   "Can Undo?"
         Height          =   375
         Left            =   3000
         TabIndex        =   10
         ToolTipText     =   "See if changes can be undone"
         Top             =   840
         Width           =   975
      End
      Begin VB.TextBox Text3 
         Height          =   285
         Left            =   120
         TabIndex        =   2
         Top             =   360
         Width           =   2895
      End
   End
   Begin VB.TextBox Text2 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   3135
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   3135
   End
   Begin VB.Label Label2 
      Caption         =   "Textbox only accepts uppercase values:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   720
      Width           =   3135
   End
   Begin VB.Label Label1 
      Caption         =   "Textbox only accepts numeric values:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const EM_EMPTYUNDOBUFFER = &HCD
Private Const EM_CANUNDO = &HC6
Private Const EM_GETMODIFY = &HB8
Private Const EM_SETMODIFY = &HB9
Private Const EM_UNDO = &HC7
Private Const GWL_STYLE = (-16)
Private Const ES_NUMBER = &H2000
Private Const ES_UPPERCASE = &H8&

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Sub SaveData()
Dim itextBoxCount As Integer

For itextBoxCount = 0 To Controls.Count - 1
    If TypeOf Controls(itextBoxCount) Is TextBox Then
        If Changed(Controls(itextBoxCount)) Then
            'Place code to save data here
        End If
    End If
Next
End Sub

Public Function Changed(ByVal ctlTextBox As TextBox) As Boolean
Changed = SendMessage(ctlTextBox.hwnd, EM_GETMODIFY, 0, 0) <> 0
End Function

Private Sub cmdCanUndo_Click()
MsgBox IIf(SendMessage(Text3.hwnd, EM_CANUNDO, 0, 0) <> 0, "Yes", "No"), vbInformation, "Can changes be undone?"
End Sub

Private Sub cmdChanged_Click()
MsgBox IIf(Changed(Text3), "Yes", "No"), vbInformation, "Did the text change?"
End Sub

Private Sub cmdClear_Click()
'Make the current text the undo text.
Call SendMessage(Text3.hwnd, EM_EMPTYUNDOBUFFER, 0, 0)
Call SendMessage(Text3.hwnd, EM_SETMODIFY, False, 0)
End Sub

Private Sub cmdMark_Click()
'Mark text as changed
Call SendMessage(Text3.hwnd, EM_SETMODIFY, 1, 0)
End Sub

Private Sub cmdUndo_Click()
'If can undo then make it undo changes.
If SendMessage(Text3.hwnd, EM_CANUNDO, 0, 0) <> 0 Then
    Call SendMessage(Text3.hwnd, EM_UNDO, 0, 0)
End If
End Sub

Private Sub Form_Load()
Dim l As Long
Dim r As Long
'
' Written by Dave Scarmozzino www.TheScarms.com
'
l = GetWindowLong(Text1.hwnd, GWL_STYLE)
r = SetWindowLong(Text1.hwnd, GWL_STYLE, l Or ES_NUMBER)

l = GetWindowLong(Text2.hwnd, GWL_STYLE)
r = SetWindowLong(Text2.hwnd, GWL_STYLE, l Or ES_UPPERCASE)
End Sub


Private Sub Text3_Change()

End Sub


